]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Drop rtpproxy
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.25" # Version number
29 CORE="142" # Core Level (Filename)
30 PAKFIRE_CORE="141" # Core Level (PAKFIRE)
31 SLOGAN="www.ipfire.org" # Software slogan
32 CONFIG_ROOT=/var/ipfire # Configuration rootdir
33 NICE=10 # Nice level
34 MAX_RETRIES=1 # prefetch/check loop
35 BUILD_IMAGES=1 # Flash and Xen Downloader
36 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
37
38 # Information from Git
39 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
40 GIT_TAG="$(git tag | tail -1)" # Git Tag
41 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
42
43 TOOLCHAINVER=20200108
44
45 ###############################################################################
46 #
47 # Beautifying variables & presentation & input output interface
48 #
49 ###############################################################################
50
51 # Remember if the shell is interactive or not
52 if [ -t 0 ] && [ -t 1 ]; then
53 INTERACTIVE=true
54 else
55 INTERACTIVE=false
56 fi
57
58 # Sets or adjusts pretty formatting variables
59 resize_terminal() {
60 ## Screen Dimentions
61 # Find current screen size
62 COLUMNS=$(tput cols)
63
64 # When using remote connections, such as a serial port, stty size returns 0
65 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
66 COLUMNS=80
67 fi
68
69 # Measurements for positioning result messages
70 OPTIONS_WIDTH=20
71 TIME_WIDTH=12
72 STATUS_WIDTH=8
73 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
74 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
75
76 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
77 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
78 }
79
80 # Initially setup terminal
81 resize_terminal
82
83 # Call resize_terminal when terminal is being resized
84 trap "resize_terminal" WINCH
85
86 # Define color for messages
87 BOLD="\\033[1;39m"
88 DONE="\\033[1;32m"
89 SKIP="\\033[1;34m"
90 WARN="\\033[1;35m"
91 FAIL="\\033[1;31m"
92 NORMAL="\\033[0;39m"
93
94 # New architecture variables
95 HOST_ARCH="$(uname -m)"
96
97 PWD=$(pwd)
98 BASENAME=$(basename $0)
99
100 # Debian specific settings
101 if [ ! -e /etc/debian_version ]; then
102 FULLPATH=`which $0`
103 else
104 if [ -x /usr/bin/realpath ]; then
105 FULLPATH=`/usr/bin/realpath $0`
106 else
107 echo "ERROR: Need to do apt-get install realpath"
108 exit 1
109 fi
110 fi
111
112 # This is the directory where make.sh is in
113 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
114
115 LOGFILE=$BASEDIR/log/_build.preparation.log
116 export LOGFILE
117 DIR_CHK=$BASEDIR/cache/check
118 mkdir $BASEDIR/log/ 2>/dev/null
119
120 system_processors() {
121 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
122 }
123
124 system_memory() {
125 local key val unit
126
127 while read -r key val unit; do
128 case "${key}" in
129 MemTotal:*)
130 # Convert to MB
131 echo "$(( ${val} / 1024 ))"
132 break
133 ;;
134 esac
135 done < /proc/meminfo
136 }
137
138 configure_build() {
139 local build_arch="${1}"
140
141 if [ "${build_arch}" = "default" ]; then
142 build_arch="$(configure_build_guess)"
143 fi
144
145 case "${build_arch}" in
146 x86_64)
147 BUILDTARGET="${build_arch}-unknown-linux-gnu"
148 CROSSTARGET="${build_arch}-cross-linux-gnu"
149 BUILD_PLATFORM="x86"
150 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
151 ;;
152
153 i586)
154 BUILDTARGET="${build_arch}-pc-linux-gnu"
155 CROSSTARGET="${build_arch}-cross-linux-gnu"
156 BUILD_PLATFORM="x86"
157 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
158 ;;
159
160 aarch64)
161 BUILDTARGET="${build_arch}-unknown-linux-gnu"
162 CROSSTARGET="${build_arch}-cross-linux-gnu"
163 BUILD_PLATFORM="arm"
164 CFLAGS_ARCH=""
165 ;;
166
167 armv7hl)
168 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
169 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
170 BUILD_PLATFORM="arm"
171 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
172 ;;
173
174 armv5tel)
175 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
176 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
177 BUILD_PLATFORM="arm"
178 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
179 RUSTFLAGS="-Ccodegen-units=1"
180 ;;
181
182 *)
183 exiterror "Cannot build for architure ${build_arch}"
184 ;;
185 esac
186
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required "${build_arch}"; then
189 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
190
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER="${qemu_build_helper}"
193 else
194 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
195 fi
196 fi
197
198 BUILD_ARCH="${build_arch}"
199 TOOLS_DIR="/tools_${BUILD_ARCH}"
200
201 # Enables hardening
202 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
203
204 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
205 CXXFLAGS="${CFLAGS}"
206
207 # Determine parallelism
208 # We assume that each process consumes about
209 # 128MB of memory. Therefore we find out how
210 # many processes fit into memory.
211 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
212 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
213
214 local parallelism
215 if [ ${mem_max} -lt ${cpu_max} ]; then
216 parallelism=${mem_max}
217 else
218 parallelism=${cpu_max}
219 fi
220
221 # Use this as default PARALLELISM
222 DEFAULT_PARALLELISM="${parallelism}"
223
224 # Compression parameters
225 # We use mode 8 for reasonable memory usage when decompressing
226 # but with overall good compression
227 XZ_OPT="-8"
228
229 # We try to use as many cores as possible
230 XZ_OPT="${XZ_OPT} -T0"
231
232 # We need to limit memory because XZ uses too much when running
233 # in parallel and it isn't very smart in limiting itself.
234 # We allow XZ to use up to 70% of all system memory.
235 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
236
237 # XZ memory cannot be larger than 2GB on 32 bit systems
238 case "${build_arch}" in
239 i*86|armv*)
240 if [ ${xz_memory} -gt 2048 ]; then
241 xz_memory=2048
242 fi
243 ;;
244 esac
245
246 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
247 }
248
249 configure_build_guess() {
250 case "${HOST_ARCH}" in
251 x86_64)
252 echo "x86_64"
253 ;;
254 i?86)
255 echo "i586"
256 ;;
257
258 aarch64)
259 echo "aarch64"
260 ;;
261
262 armv7*|armv6*|armv5*)
263 echo "armv5tel"
264 ;;
265
266 *)
267 exiterror "Cannot guess build architecture"
268 ;;
269 esac
270 }
271
272 stdumount() {
273 umount $BASEDIR/build/sys 2>/dev/null;
274 umount $BASEDIR/build/dev/shm 2>/dev/null;
275 umount $BASEDIR/build/dev/pts 2>/dev/null;
276 umount $BASEDIR/build/dev 2>/dev/null;
277 umount $BASEDIR/build/proc 2>/dev/null;
278 umount $BASEDIR/build/install/mnt 2>/dev/null;
279 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
280 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
281 umount $BASEDIR/build/usr/src/config 2>/dev/null;
282 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
283 umount $BASEDIR/build/usr/src/html 2>/dev/null;
284 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
285 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
286 umount $BASEDIR/build/usr/src/log 2>/dev/null;
287 umount $BASEDIR/build/usr/src/src 2>/dev/null;
288 umount $BASEDIR/build/usr/src 2>/dev/null;
289 }
290
291 now() {
292 date -u "+%s"
293 }
294
295 format_runtime() {
296 local seconds=${1}
297
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
304 printf "%d:%02d\n" \
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
307 else
308 printf "%d\n" "${seconds}"
309 fi
310 }
311
312 print_line() {
313 local line="$@"
314
315 printf "%-${LINE_WIDTH}s" "${line}"
316 }
317
318 _print_line() {
319 local status="${1}"
320 shift
321
322 if ${INTERACTIVE}; then
323 printf "${!status}"
324 fi
325
326 print_line "$@"
327
328 if ${INTERACTIVE}; then
329 printf "${NORMAL}"
330 fi
331 }
332
333 print_headline() {
334 _print_line BOLD "$@"
335 }
336
337 print_error() {
338 _print_line FAIL "$@"
339 }
340
341 print_package() {
342 local name="${1}"
343 shift
344
345 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
346 local options="$@"
347
348 local string="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string="${string} (${version})"
351 fi
352
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
355 }
356
357 print_runtime() {
358 local runtime=$(format_runtime $@)
359
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
362 else
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
364 fi
365 }
366
367 print_status() {
368 local status="${1}"
369
370 local color="${!status}"
371
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
374 else
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
376 fi
377 }
378
379 print_build_stage() {
380 print_headline "$@"
381
382 # end line
383 printf "\n"
384 }
385
386 print_build_summary() {
387 local runtime=$(format_runtime $@)
388
389 print_line "*** Build finished in ${runtime}"
390 print_status DONE
391 }
392
393 exiterror() {
394 stdumount
395 for i in `seq 0 7`; do
396 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
397 losetup -d /dev/loop${i} 2>/dev/null
398 fi;
399 done
400
401 # Dump logfile
402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
403 echo # empty line
404
405 local line
406 while read -r line; do
407 echo " ${line}"
408 done <<< "$(tail -n30 ${LOGFILE})"
409 fi
410
411 echo # empty line
412
413 local line
414 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error "${line}"
416 print_status FAIL
417 done
418
419 exit 1
420 }
421
422 prepareenv() {
423 # Are we running the right shell?
424 if [ -z "${BASH}" ]; then
425 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
426 fi
427
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror "Not running BASH shell."
430 fi
431
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
434
435 # Resetting our nice level
436 if ! renice ${NICE} $$ >/dev/null; then
437 exiterror "Failed to set nice level to ${NICE}"
438 fi
439
440 # Checking if running as root user
441 if [ $(id -u) -ne 0 ]; then
442 exiterror "root privileges required for building"
443 fi
444
445 # Checking for necessary temporary space
446 print_line "Checking for necessary space on disk $BASE_DEV"
447 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
448 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
449 if (( 2048000 > $BASE_ASPACE )); then
450 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
451 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
452 print_status FAIL
453 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
454 fi
455 else
456 print_status DONE
457 fi
458
459 # Set umask
460 umask 022
461
462 # Set LFS Directory
463 LFS=$BASEDIR/build
464
465 # Setup environment
466 set +h
467 LC_ALL=POSIX
468 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
469 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
470
471 # Make some extra directories
472 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
473 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
474 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
475 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
476
477 if [ "${ENABLE_RAMDISK}" = "on" ]; then
478 mkdir -p $BASEDIR/build/usr/src
479 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
480 fi
481
482 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
483
484 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
485 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
486
487 # Make all sources and proc available under lfs build
488 mount --bind /dev $BASEDIR/build/dev
489 mount --bind /dev/pts $BASEDIR/build/dev/pts
490 mount --bind /dev/shm $BASEDIR/build/dev/shm
491 mount --bind /proc $BASEDIR/build/proc
492 mount --bind /sys $BASEDIR/build/sys
493 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
494 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
495 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
496 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
497 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
498 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
499 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
500 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
501 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
502
503 # Run LFS static binary creation scripts one by one
504 export CCACHE_DIR=$BASEDIR/ccache
505 export CCACHE_COMPRESS=1
506 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
507
508 # Remove pre-install list of installed files in case user erase some files before rebuild
509 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
510
511 # Prepare string for /etc/system-release.
512 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
513
514 case "${GIT_BRANCH}" in
515 core*|beta?|rc?)
516 system_release="${system_release} - ${GIT_BRANCH}"
517 ;;
518 *)
519 system_release="${system_release} - Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
520 ;;
521 esac
522
523 # Append -dirty tag for local changes
524 if [ "$(git status -s | wc -l)" != "0" ]; then
525 system_release="${system_release}-dirty"
526 fi
527
528 # Export variable
529 SYSTEM_RELEASE="${system_release}"
530
531 # Decide on PAKFIRE_TREE
532 case "${GIT_BRANCH}" in
533 core*)
534 PAKFIRE_TREE="stable"
535 ;;
536 master)
537 PAKFIRE_TREE="testing"
538 ;;
539 *)
540 PAKFIRE_TREE="unstable"
541 ;;
542 esac
543
544 # Setup ccache cache size
545 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
546 }
547
548 enterchroot() {
549 # Install QEMU helper, if needed
550 qemu_install_helper
551
552 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
553
554 PATH="${PATH}" chroot ${LFS} env -i \
555 HOME="/root" \
556 TERM="${TERM}" \
557 PS1="${PS1}" \
558 PATH="${PATH}" \
559 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
560 PAKFIRE_CORE="${PAKFIRE_CORE}" \
561 PAKFIRE_TREE="${PAKFIRE_TREE}" \
562 NAME="${NAME}" \
563 SNAME="${SNAME}" \
564 VERSION="${VERSION}" \
565 CORE="${CORE}" \
566 SLOGAN="${SLOGAN}" \
567 TOOLS_DIR="${TOOLS_DIR}" \
568 CONFIG_ROOT="${CONFIG_ROOT}" \
569 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
570 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
571 RUSTFLAGS="${RUSTFLAGS}" \
572 BUILDTARGET="${BUILDTARGET}" \
573 CROSSTARGET="${CROSSTARGET}" \
574 BUILD_ARCH="${BUILD_ARCH}" \
575 BUILD_PLATFORM="${BUILD_PLATFORM}" \
576 CCACHE_DIR=/usr/src/ccache \
577 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
578 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
579 GOCACHE="/usr/src/ccache/go" \
580 KVER="${KVER}" \
581 XZ_OPT="${XZ_OPT}" \
582 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
583 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
584 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
585 $(fake_environ) \
586 $(qemu_environ) \
587 "$@"
588 }
589
590 entershell() {
591 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
592 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
593 fi
594
595 echo "Entering to a shell inside LFS chroot, go out with exit"
596 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
597
598 if enterchroot bash -i; then
599 stdumount
600 else
601 print_status FAIL
602 exiterror "chroot error"
603 fi
604 }
605
606 lfsmakecommoncheck() {
607 # Script present?
608 if [ ! -f $BASEDIR/lfs/$1 ]; then
609 exiterror "No such file or directory: $BASEDIR/$1"
610 fi
611
612 # Print package name and version
613 print_package $@
614
615 # Check if this package is supported by our architecture.
616 # If no SUP_ARCH is found, we assume the package can be built for all.
617 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
618 # Check if package supports ${BUILD_ARCH} or all architectures.
619 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
620 print_runtime 0
621 print_status SKIP
622 return 1
623 fi
624 fi
625
626 # Script slipped?
627 local i
628 for i in $SKIP_PACKAGE_LIST
629 do
630 if [ "$i" == "$1" ]; then
631 print_status SKIP
632 return 1;
633 fi
634 done
635
636 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
637
638 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
639 MESSAGE="$1\t " download >> $LOGFILE 2>&1
640 if [ $? -ne 0 ]; then
641 exiterror "Download error in $1"
642 fi
643
644 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
645 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
646 if [ $? -ne 0 ]; then
647 exiterror "md5sum error in $1, check file in cache or signature"
648 fi
649
650 return 0 # pass all!
651 }
652
653 lfsmake1() {
654 lfsmakecommoncheck $*
655 [ $? == 1 ] && return 0
656
657 cd $BASEDIR/lfs && env -i \
658 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
659 CCACHE_DIR="${CCACHE_DIR}" \
660 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
661 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
662 CFLAGS="${CFLAGS}" \
663 CXXFLAGS="${CXXFLAGS}" \
664 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
665 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
666 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
667 make -f $* \
668 TOOLCHAIN=1 \
669 TOOLS_DIR="${TOOLS_DIR}" \
670 CROSSTARGET="${CROSSTARGET}" \
671 BUILDTARGET="${BUILDTARGET}" \
672 BUILD_ARCH="${BUILD_ARCH}" \
673 BUILD_PLATFORM="${BUILD_PLATFORM}" \
674 LFS_BASEDIR="${BASEDIR}" \
675 ROOT="${LFS}" \
676 KVER="${KVER}" \
677 install >> $LOGFILE 2>&1 &
678
679 if ! wait_until_finished $!; then
680 print_status FAIL
681 exiterror "Building $*"
682 fi
683
684 print_status DONE
685 }
686
687 lfsmake2() {
688 lfsmakecommoncheck $*
689 [ $? == 1 ] && return 0
690
691 local PS1='\u:\w$ '
692
693 enterchroot \
694 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
695 make -f $* \
696 LFS_BASEDIR=/usr/src install" \
697 >> ${LOGFILE} 2>&1 &
698
699 if ! wait_until_finished $!; then
700 print_status FAIL
701 exiterror "Building $*"
702 fi
703
704 print_status DONE
705 }
706
707 ipfiredist() {
708 lfsmakecommoncheck $*
709 [ $? == 1 ] && return 0
710
711 local PS1='\u:\w$ '
712
713 enterchroot \
714 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
715 >> ${LOGFILE} 2>&1 &
716
717 if ! wait_until_finished $!; then
718 print_status FAIL
719 exiterror "Packaging $*"
720 fi
721
722 print_status DONE
723 }
724
725 wait_until_finished() {
726 local pid=${1}
727
728 local start_time=$(now)
729
730 # Show progress
731 if ${INTERACTIVE}; then
732 # Wait a little just in case the process
733 # has finished very quickly.
734 sleep 0.1
735
736 local runtime
737 while kill -0 ${pid} 2>/dev/null; do
738 print_runtime $(( $(now) - ${start_time} ))
739
740 # Wait a little
741 sleep 1
742 done
743 fi
744
745 # Returns the exit code of the child process
746 wait ${pid}
747 local ret=$?
748
749 if ! ${INTERACTIVE}; then
750 print_runtime $(( $(now) - ${start_time} ))
751 fi
752
753 return ${ret}
754 }
755
756 fake_environ() {
757 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
758
759 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
760
761 # Fake kernel version, because some of the packages do not compile
762 # with kernel 3.0 and later.
763 env="${env} UTS_RELEASE=${KVER}-ipfire"
764
765 # Fake machine version.
766 env="${env} UTS_MACHINE=${BUILD_ARCH}"
767
768 echo "${env}"
769 }
770
771 qemu_environ() {
772 local env
773
774 # Don't add anything if qemu is not used.
775 if ! qemu_is_required; then
776 return
777 fi
778
779 # Set default qemu options
780 case "${BUILD_ARCH}" in
781 arm*)
782 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
783
784 env="${env} QEMU_CPU=${QEMU_CPU}"
785 ;;
786 esac
787
788 # Enable QEMU strace
789 #env="${env} QEMU_STRACE=1"
790
791 echo "${env}"
792 }
793
794 qemu_is_required() {
795 local build_arch="${1}"
796
797 if [ -z "${build_arch}" ]; then
798 build_arch="${BUILD_ARCH}"
799 fi
800
801 case "${HOST_ARCH},${build_arch}" in
802 x86_64,arm*|i?86,arm*|i?86,x86_64)
803 return 0
804 ;;
805 *)
806 return 1
807 ;;
808 esac
809 }
810
811 qemu_install_helper() {
812 # Do nothing, if qemu is not required
813 if ! qemu_is_required; then
814 return 0
815 fi
816
817 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
818 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
819 fi
820
821 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
822 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
823 fi
824
825
826 if [ -z "${QEMU_TARGET_HELPER}" ]; then
827 exiterror "QEMU_TARGET_HELPER not set"
828 fi
829
830 # Check if the helper is already installed.
831 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
832 return 0
833 fi
834
835 # Try to find a suitable binary that we can install
836 # to the build environment.
837 local file
838 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
839 # file must exist and be executable.
840 [ -x "${file}" ] || continue
841
842 # Must be static.
843 file_is_static "${file}" || continue
844
845 local dirname="${LFS}$(dirname "${file}")"
846 mkdir -p "${dirname}"
847
848 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
849 return 0
850 done
851
852 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
853 }
854
855 qemu_find_build_helper_name() {
856 local build_arch="${1}"
857
858 local magic
859 case "${build_arch}" in
860 arm*)
861 magic="7f454c4601010100000000000000000002002800"
862 ;;
863 x86_64)
864 magic="7f454c4602010100000000000000000002003e00"
865 ;;
866 esac
867
868 [ -z "${magic}" ] && return 1
869
870 local file
871 for file in /proc/sys/fs/binfmt_misc/*; do
872 # skip write only register entry
873 [ $(basename "${file}") = "register" ] && continue
874 # Search for the file with the correct magic value.
875 grep -qE "^magic ${magic}$" "${file}" || continue
876
877 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
878
879 [ -n "${interpreter}" ] || continue
880 [ "${interpreter:0:1}" = "/" ] || continue
881 [ -x "${interpreter}" ] || continue
882
883 echo "${interpreter}"
884 return 0
885 done
886
887 return 1
888 }
889
890 file_is_static() {
891 local file="${1}"
892
893 file ${file} 2>/dev/null | grep -q "statically linked"
894 }
895
896 update_language_list() {
897 local path="${1}"
898
899 local lang
900 for lang in ${path}/*.po; do
901 lang="$(basename "${lang}")"
902 echo "${lang%*.po}"
903 done | sort -u > "${path}/LINGUAS"
904 }
905
906 contributors() {
907 local commits name
908
909 git shortlog --summary --numbered | while read -r commits name; do
910 echo "${name}"
911 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
912 }
913
914 update_contributors() {
915 echo -n "Updating list of contributors"
916
917 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
918
919 # Edit contributors into credits.cgi
920 local tmp="$(mktemp)"
921
922 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
923 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
924
925 # Copy back modified content
926 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
927 unlink "${tmp}"
928
929 print_status DONE
930 return 0
931 }
932
933 # Default settings
934 CCACHE_CACHE_SIZE="4G"
935 ENABLE_RAMDISK="auto"
936
937 # Load configuration file
938 if [ -f .config ]; then
939 . .config
940 fi
941
942 # TARGET_ARCH is BUILD_ARCH now
943 if [ -n "${TARGET_ARCH}" ]; then
944 BUILD_ARCH="${TARGET_ARCH}"
945 unset TARGET_ARCH
946 fi
947
948 # Get some information about the host system
949 SYSTEM_PROCESSORS="$(system_processors)"
950 SYSTEM_MEMORY="$(system_memory)"
951
952 if [ -n "${BUILD_ARCH}" ]; then
953 configure_build "${BUILD_ARCH}"
954 else
955 configure_build "default"
956 fi
957
958 # Automatically enable/disable ramdisk usage
959 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
960 # Enable only when the host system has 4GB of RAM or more
961 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
962 ENABLE_RAMDISK="on"
963 fi
964 fi
965
966 buildtoolchain() {
967 local error=false
968 case "${BUILD_ARCH}:${HOST_ARCH}" in
969 # x86_64
970 x86_64:x86_64)
971 # This is working.
972 ;;
973
974 # x86
975 i586:i586|i586:i686|i586:x86_64)
976 # These are working.
977 ;;
978 i586:*)
979 error=true
980 ;;
981
982 # ARM
983 arvm7hl:armv7hl|armv7hl:armv7l)
984 # These are working.
985 ;;
986
987 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
988 # These are working.
989 ;;
990 armv5tel:*)
991 error=true
992 ;;
993 esac
994
995 ${error} && \
996 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
997
998 local gcc=$(type -p gcc)
999 if [ -z "${gcc}" ]; then
1000 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1001 fi
1002
1003 # Check ${TOOLS_DIR} symlink
1004 if [ -h "${TOOLS_DIR}" ]; then
1005 rm -f "${TOOLS_DIR}"
1006 fi
1007
1008 if [ ! -e "${TOOLS_DIR}" ]; then
1009 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1010 fi
1011
1012 if [ ! -h "${TOOLS_DIR}" ]; then
1013 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1014 fi
1015
1016 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1017 export LOGFILE
1018
1019 lfsmake1 stage1
1020 lfsmake1 ccache PASS=1
1021 lfsmake1 binutils PASS=1
1022 lfsmake1 gcc PASS=1
1023 lfsmake1 linux KCFG="-headers"
1024 lfsmake1 glibc
1025 lfsmake1 gcc PASS=L
1026 lfsmake1 binutils PASS=2
1027 lfsmake1 gcc PASS=2
1028 lfsmake1 zlib
1029 lfsmake1 ccache PASS=2
1030 lfsmake1 tcl
1031 lfsmake1 expect
1032 lfsmake1 dejagnu
1033 lfsmake1 pkg-config
1034 lfsmake1 ncurses
1035 lfsmake1 bash
1036 lfsmake1 bzip2
1037 lfsmake1 automake
1038 lfsmake1 coreutils
1039 lfsmake1 diffutils
1040 lfsmake1 findutils
1041 lfsmake1 gawk
1042 lfsmake1 gettext
1043 lfsmake1 grep
1044 lfsmake1 gzip
1045 lfsmake1 m4
1046 lfsmake1 make
1047 lfsmake1 patch
1048 lfsmake1 perl
1049 lfsmake1 python3
1050 lfsmake1 sed
1051 lfsmake1 tar
1052 lfsmake1 texinfo
1053 lfsmake1 xz
1054 lfsmake1 bison
1055 lfsmake1 flex
1056 lfsmake1 fake-environ
1057 lfsmake1 strip
1058 lfsmake1 cleanup-toolchain
1059 }
1060
1061 buildbase() {
1062 LOGFILE="$BASEDIR/log/_build.base.log"
1063 export LOGFILE
1064 lfsmake2 stage2
1065 lfsmake2 linux KCFG="-headers"
1066 lfsmake2 man-pages
1067 lfsmake2 glibc
1068 lfsmake2 tzdata
1069 lfsmake2 cleanup-toolchain
1070 lfsmake2 zlib
1071 lfsmake2 binutils
1072 lfsmake2 gmp
1073 lfsmake2 gmp-compat
1074 lfsmake2 mpfr
1075 lfsmake2 libmpc
1076 lfsmake2 file
1077 lfsmake2 gcc
1078 lfsmake2 sed
1079 lfsmake2 autoconf
1080 lfsmake2 automake
1081 lfsmake2 berkeley
1082 lfsmake2 coreutils
1083 lfsmake2 iana-etc
1084 lfsmake2 m4
1085 lfsmake2 bison
1086 lfsmake2 ncurses
1087 lfsmake2 procps
1088 lfsmake2 libtool
1089 lfsmake2 perl
1090 lfsmake2 readline
1091 lfsmake2 readline-compat
1092 lfsmake2 bzip2
1093 lfsmake2 xz
1094 lfsmake2 pcre
1095 lfsmake2 pcre-compat
1096 lfsmake2 bash
1097 lfsmake2 diffutils
1098 lfsmake2 e2fsprogs
1099 lfsmake2 ed
1100 lfsmake2 findutils
1101 lfsmake2 flex
1102 lfsmake2 gawk
1103 lfsmake2 gettext
1104 lfsmake2 grep
1105 lfsmake2 groff
1106 lfsmake2 gperf
1107 lfsmake2 gzip
1108 lfsmake2 hostname
1109 lfsmake2 iproute2
1110 lfsmake2 jwhois
1111 lfsmake2 kbd
1112 lfsmake2 less
1113 lfsmake2 pkg-config
1114 lfsmake2 make
1115 lfsmake2 man
1116 lfsmake2 kmod
1117 lfsmake2 net-tools
1118 lfsmake2 patch
1119 lfsmake2 psmisc
1120 lfsmake2 shadow
1121 lfsmake2 sysklogd
1122 lfsmake2 sysvinit
1123 lfsmake2 tar
1124 lfsmake2 texinfo
1125 lfsmake2 util-linux
1126 lfsmake2 udev
1127 lfsmake2 vim
1128 }
1129
1130 buildipfire() {
1131 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1132 export LOGFILE
1133 lfsmake2 configroot
1134 lfsmake2 initscripts
1135 lfsmake2 backup
1136 lfsmake2 openssl
1137 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1138 lfsmake2 popt
1139 lfsmake2 libedit
1140 lfsmake2 libusb
1141 lfsmake2 libusb-compat
1142 lfsmake2 libpcap
1143 lfsmake2 ppp
1144 lfsmake2 pptp
1145 lfsmake2 unzip
1146 lfsmake2 which
1147 lfsmake2 linux-firmware
1148 lfsmake2 dvb-firmwares
1149 lfsmake2 xr819-firmware
1150 lfsmake2 zd1211-firmware
1151 lfsmake2 rpi-firmware
1152 lfsmake2 intel-microcode
1153 lfsmake2 pcengines-apu-firmware
1154 lfsmake2 bc
1155 lfsmake2 u-boot MKIMAGE=1
1156 lfsmake2 cpio
1157 lfsmake2 mdadm
1158 lfsmake2 dracut
1159 lfsmake2 libaio
1160 lfsmake2 lvm2
1161 lfsmake2 multipath-tools
1162 lfsmake2 freetype
1163 lfsmake2 libmnl
1164 lfsmake2 libnfnetlink
1165 lfsmake2 libnetfilter_queue
1166 lfsmake2 libnetfilter_conntrack
1167 lfsmake2 libnetfilter_cthelper
1168 lfsmake2 libnetfilter_cttimeout
1169 lfsmake2 iptables
1170 lfsmake2 screen
1171 lfsmake2 elfutils
1172
1173 case "${BUILD_ARCH}" in
1174 x86_64|aarch64)
1175 lfsmake2 linux KCFG=""
1176 # lfsmake2 backports KCFG=""
1177 # lfsmake2 e1000e KCFG=""
1178 # lfsmake2 igb KCFG=""
1179 # lfsmake2 ixgbe KCFG=""
1180 lfsmake2 xtables-addons KCFG=""
1181 lfsmake2 linux-initrd KCFG=""
1182 ;;
1183 i586)
1184 # x86-pae (Native and new XEN) kernel build
1185 lfsmake2 linux KCFG="-pae"
1186 # lfsmake2 backports KCFG="-pae"
1187 # lfsmake2 e1000e KCFG="-pae"
1188 # lfsmake2 igb KCFG="-pae"
1189 # lfsmake2 ixgbe KCFG="-pae"
1190 lfsmake2 xtables-addons KCFG="-pae"
1191 lfsmake2 linux-initrd KCFG="-pae"
1192
1193 # x86 kernel build
1194 lfsmake2 linux KCFG=""
1195 # lfsmake2 backports KCFG=""
1196 # lfsmake2 e1000e KCFG=""
1197 # lfsmake2 igb KCFG=""
1198 # lfsmake2 ixgbe KCFG=""
1199 lfsmake2 xtables-addons KCFG=""
1200 lfsmake2 linux-initrd KCFG=""
1201 ;;
1202
1203 armv5tel)
1204 # arm multi platform (Panda, Wandboard ...) kernel build
1205 lfsmake2 linux KCFG="-multi"
1206 # lfsmake2 backports KCFG="-multi"
1207 # lfsmake2 e1000e KCFG="-multi"
1208 # lfsmake2 igb KCFG="-multi"
1209 # lfsmake2 ixgbe KCFG="-multi"
1210 lfsmake2 xtables-addons KCFG="-multi"
1211 lfsmake2 linux-initrd KCFG="-multi"
1212 ;;
1213 esac
1214 lfsmake2 xtables-addons USPACE="1"
1215 lfsmake2 libgpg-error
1216 lfsmake2 libgcrypt
1217 lfsmake2 libassuan
1218 lfsmake2 nettle
1219 lfsmake2 json-c
1220 lfsmake2 libconfig
1221 lfsmake2 libevent
1222 lfsmake2 libevent2
1223 lfsmake2 expat
1224 lfsmake2 apr
1225 lfsmake2 aprutil
1226 lfsmake2 unbound
1227 lfsmake2 gnutls
1228 lfsmake2 bind
1229 lfsmake2 dhcp
1230 lfsmake2 dhcpcd
1231 lfsmake2 boost
1232 lfsmake2 linux-atm
1233 lfsmake2 gdbm
1234 lfsmake2 pam
1235 lfsmake2 curl
1236 lfsmake2 tcl
1237 lfsmake2 sqlite
1238 lfsmake2 libffi
1239 lfsmake2 python
1240 lfsmake2 python3
1241 lfsmake2 grub
1242 lfsmake2 efivar
1243 lfsmake2 efibootmgr
1244 lfsmake2 ca-certificates
1245 lfsmake2 fireinfo
1246 lfsmake2 libnet
1247 lfsmake2 libnl
1248 lfsmake2 libnl-3
1249 lfsmake2 libidn
1250 lfsmake2 nasm
1251 lfsmake2 libjpeg
1252 lfsmake2 libjpeg-compat
1253 lfsmake2 libexif
1254 lfsmake2 libpng
1255 lfsmake2 libtiff
1256 lfsmake2 libart
1257 lfsmake2 gd
1258 lfsmake2 slang
1259 lfsmake2 newt
1260 lfsmake2 libsmooth
1261 lfsmake2 attr
1262 lfsmake2 acl
1263 lfsmake2 libcap
1264 lfsmake2 libcap-ng
1265 lfsmake2 pciutils
1266 lfsmake2 usbutils
1267 lfsmake2 libxml2
1268 lfsmake2 libxslt
1269 lfsmake2 BerkeleyDB
1270 lfsmake2 cyrus-sasl
1271 lfsmake2 openldap
1272 lfsmake2 apache2
1273 lfsmake2 web-user-interface
1274 lfsmake2 flag-icons
1275 lfsmake2 jquery
1276 lfsmake2 bootstrap
1277 lfsmake2 arping
1278 lfsmake2 beep
1279 lfsmake2 libarchive
1280 lfsmake2 cmake
1281 lfsmake2 libssh
1282 lfsmake2 cdrkit
1283 lfsmake2 dosfstools
1284 lfsmake2 reiserfsprogs
1285 lfsmake2 xfsprogs
1286 lfsmake2 sysfsutils
1287 lfsmake2 fuse
1288 lfsmake2 ntfs-3g
1289 lfsmake2 ethtool
1290 lfsmake2 fcron
1291 lfsmake2 perl-GD
1292 lfsmake2 GD-Graph
1293 lfsmake2 GD-TextUtil
1294 lfsmake2 perl-Device-SerialPort
1295 lfsmake2 perl-Device-Modem
1296 lfsmake2 perl-Apache-Htpasswd
1297 lfsmake2 gnupg
1298 lfsmake2 hdparm
1299 lfsmake2 sdparm
1300 lfsmake2 mtools
1301 lfsmake2 whatmask
1302 lfsmake2 conntrack-tools
1303 lfsmake2 libupnp
1304 lfsmake2 ipaddr
1305 lfsmake2 iputils
1306 lfsmake2 l7-protocols
1307 lfsmake2 hwdata
1308 lfsmake2 logrotate
1309 lfsmake2 logwatch
1310 lfsmake2 misc-progs
1311 lfsmake2 nano
1312 lfsmake2 URI
1313 lfsmake2 perl-CGI
1314 lfsmake2 perl-Switch
1315 lfsmake2 HTML-Tagset
1316 lfsmake2 HTML-Parser
1317 lfsmake2 HTML-Template
1318 lfsmake2 Compress-Zlib
1319 lfsmake2 Digest
1320 lfsmake2 Digest-SHA1
1321 lfsmake2 Digest-HMAC
1322 lfsmake2 libwww-perl
1323 lfsmake2 Net-DNS
1324 lfsmake2 Net-IPv4Addr
1325 lfsmake2 Net_SSLeay
1326 lfsmake2 IO-Stringy
1327 lfsmake2 IO-Socket-SSL
1328 lfsmake2 Unix-Syslog
1329 lfsmake2 Mail-Tools
1330 lfsmake2 MIME-Tools
1331 lfsmake2 Net-Server
1332 lfsmake2 Convert-TNEF
1333 lfsmake2 Convert-UUlib
1334 lfsmake2 Archive-Tar
1335 lfsmake2 Archive-Zip
1336 lfsmake2 Text-Tabs+Wrap
1337 lfsmake2 Locale-Country
1338 lfsmake2 XML-Parser
1339 lfsmake2 Crypt-PasswdMD5
1340 lfsmake2 Net-Telnet
1341 lfsmake2 python-setuptools
1342 lfsmake2 python-clientform
1343 lfsmake2 python-mechanize
1344 lfsmake2 python-feedparser
1345 lfsmake2 python-rssdler
1346 lfsmake2 python-inotify
1347 lfsmake2 python-docutils
1348 lfsmake2 python-daemon
1349 lfsmake2 python-ipaddress
1350 lfsmake2 glib
1351 lfsmake2 GeoIP
1352 lfsmake2 geoip-database
1353 lfsmake2 ntp
1354 lfsmake2 openssh
1355 lfsmake2 fontconfig
1356 lfsmake2 dejavu-fonts-ttf
1357 lfsmake2 ubuntu-font-family
1358 lfsmake2 freefont
1359 lfsmake2 pixman
1360 lfsmake2 cairo
1361 lfsmake2 pango
1362 lfsmake2 rrdtool
1363 lfsmake2 setup
1364 lfsmake2 libdnet
1365 lfsmake2 rust
1366 lfsmake2 jansson
1367 lfsmake2 yaml
1368 lfsmake2 libhtp
1369 lfsmake2 colm
1370 lfsmake2 ragel
1371 lfsmake2 hyperscan
1372 lfsmake2 suricata
1373 lfsmake2 oinkmaster
1374 lfsmake2 ids-ruleset-sources
1375 lfsmake2 squid
1376 lfsmake2 squidguard
1377 lfsmake2 calamaris
1378 lfsmake2 tcpdump
1379 lfsmake2 traceroute
1380 lfsmake2 vlan
1381 lfsmake2 wireless
1382 lfsmake2 pakfire
1383 lfsmake2 spandsp
1384 lfsmake2 lz4
1385 lfsmake2 lzo
1386 lfsmake2 openvpn
1387 lfsmake2 mpage
1388 lfsmake2 dbus
1389 lfsmake2 intltool
1390 lfsmake2 libdaemon
1391 lfsmake2 avahi
1392 lfsmake2 cups
1393 lfsmake2 lcms2
1394 lfsmake2 ghostscript
1395 lfsmake2 qpdf
1396 lfsmake2 poppler
1397 lfsmake2 cups-filters
1398 lfsmake2 epson-inkjet-printer-escpr
1399 lfsmake2 foomatic
1400 lfsmake2 hplip
1401 lfsmake2 cifs-utils
1402 lfsmake2 krb5
1403 lfsmake2 samba
1404 lfsmake2 sudo
1405 lfsmake2 mc
1406 lfsmake2 wget
1407 lfsmake2 bridge-utils
1408 lfsmake2 smartmontools
1409 lfsmake2 htop
1410 lfsmake2 chkconfig
1411 lfsmake2 postfix
1412 lfsmake2 fetchmail
1413 lfsmake2 cyrus-imapd
1414 lfsmake2 clamav
1415 lfsmake2 perl-NetAddr-IP
1416 lfsmake2 spamassassin
1417 lfsmake2 perl-Net-LibIDN
1418 lfsmake2 amavisd
1419 lfsmake2 dma
1420 lfsmake2 alsa
1421 lfsmake2 mpfire
1422 lfsmake2 guardian
1423 lfsmake2 libid3tag
1424 lfsmake2 libmad
1425 lfsmake2 libogg
1426 lfsmake2 libvorbis
1427 lfsmake2 libdvbpsi
1428 lfsmake2 flac
1429 lfsmake2 lame
1430 lfsmake2 sox
1431 lfsmake2 soxr
1432 lfsmake2 libshout
1433 lfsmake2 xvid
1434 lfsmake2 libmpeg2
1435 lfsmake2 gnump3d
1436 lfsmake2 rsync
1437 lfsmake2 libtirpc
1438 lfsmake2 rpcbind
1439 lfsmake2 keyutils
1440 lfsmake2 nfs
1441 lfsmake2 gnu-netcat
1442 lfsmake2 ncat
1443 lfsmake2 nmap
1444 lfsmake2 etherwake
1445 lfsmake2 bwm-ng
1446 lfsmake2 sysstat
1447 lfsmake2 strongswan
1448 lfsmake2 rng-tools
1449 lfsmake2 lsof
1450 lfsmake2 br2684ctl
1451 lfsmake2 pcmciautils
1452 lfsmake2 lm_sensors
1453 lfsmake2 liboping
1454 lfsmake2 collectd
1455 lfsmake2 elinks
1456 lfsmake2 igmpproxy
1457 lfsmake2 fbset
1458 lfsmake2 opus
1459 lfsmake2 python-six
1460 lfsmake2 python-pyparsing
1461 lfsmake2 spice-protocol
1462 lfsmake2 spice
1463 lfsmake2 sdl
1464 lfsmake2 libusbredir
1465 lfsmake2 libseccomp
1466 lfsmake2 qemu
1467 lfsmake2 sane
1468 lfsmake2 netpbm
1469 lfsmake2 netsnmpd
1470 lfsmake2 nagios_nrpe
1471 lfsmake2 nagios-plugins
1472 lfsmake2 icinga
1473 lfsmake2 observium-agent
1474 lfsmake2 ebtables
1475 lfsmake2 faad2
1476 lfsmake2 alac
1477 lfsmake2 ffmpeg
1478 lfsmake2 vdr
1479 lfsmake2 vdr_streamdev
1480 lfsmake2 vdr_epgsearch
1481 lfsmake2 vdr_dvbapi
1482 lfsmake2 vdr_eepg
1483 lfsmake2 w_scan
1484 lfsmake2 mpd
1485 lfsmake2 libmpdclient
1486 lfsmake2 mpc
1487 lfsmake2 perl-Net-CIDR-Lite
1488 lfsmake2 perl-Net-SMTP-SSL
1489 lfsmake2 perl-MIME-Base64
1490 lfsmake2 perl-Authen-SASL
1491 lfsmake2 perl-MIME-Lite
1492 lfsmake2 perl-Email-Date-Format
1493 lfsmake2 git
1494 lfsmake2 squidclamav
1495 lfsmake2 vnstat
1496 lfsmake2 iw
1497 lfsmake2 wpa_supplicant
1498 lfsmake2 hostapd
1499 lfsmake2 pycurl
1500 lfsmake2 urlgrabber
1501 lfsmake2 syslinux
1502 lfsmake2 tftpd
1503 lfsmake2 cpufrequtils
1504 lfsmake2 bluetooth
1505 lfsmake2 gutenprint
1506 lfsmake2 apcupsd
1507 lfsmake2 iperf
1508 lfsmake2 iperf3
1509 lfsmake2 7zip
1510 lfsmake2 lynis
1511 lfsmake2 streamripper
1512 lfsmake2 sshfs
1513 lfsmake2 taglib
1514 lfsmake2 sslh
1515 lfsmake2 perl-gettext
1516 lfsmake2 perl-Sort-Naturally
1517 lfsmake2 vdradmin
1518 lfsmake2 perl-DBI
1519 lfsmake2 perl-DBD-SQLite
1520 lfsmake2 perl-File-ReadBackwards
1521 lfsmake2 openvmtools
1522 lfsmake2 motion
1523 lfsmake2 joe
1524 lfsmake2 monit
1525 lfsmake2 nut
1526 lfsmake2 watchdog
1527 lfsmake2 libpri
1528 lfsmake2 libsrtp
1529 lfsmake2 asterisk
1530 lfsmake2 usb_modeswitch
1531 lfsmake2 usb_modeswitch_data
1532 lfsmake2 zerofree
1533 lfsmake2 minicom
1534 lfsmake2 ddrescue
1535 lfsmake2 miniupnpd
1536 lfsmake2 client175
1537 lfsmake2 powertop
1538 lfsmake2 parted
1539 lfsmake2 swig
1540 lfsmake2 u-boot
1541 lfsmake2 u-boot-kirkwood
1542 lfsmake2 u-boot-friendlyarm
1543 lfsmake2 python-typing
1544 lfsmake2 python-m2crypto
1545 lfsmake2 wireless-regdb
1546 lfsmake2 crda
1547 lfsmake2 libsolv
1548 lfsmake2 python-distutils-extra
1549 lfsmake2 python-lzma
1550 lfsmake2 python-progressbar
1551 lfsmake2 python-xattr
1552 lfsmake2 ddns
1553 lfsmake2 python3-setuptools
1554 lfsmake2 python3-setuptools-scm
1555 lfsmake2 python3-six
1556 lfsmake2 python3-dateutil
1557 lfsmake2 python3-jmespath
1558 lfsmake2 python3-colorama
1559 lfsmake2 python3-docutils
1560 lfsmake2 python3-yaml
1561 lfsmake2 python3-s3transfer
1562 lfsmake2 python3-rsa
1563 lfsmake2 python3-pyasn1
1564 lfsmake2 python3-botocore
1565 lfsmake2 python3-llfuse
1566 lfsmake2 python3-msgpack
1567 lfsmake2 aws-cli
1568 lfsmake2 transmission
1569 lfsmake2 dpfhack
1570 lfsmake2 lcd4linux
1571 lfsmake2 mtr
1572 lfsmake2 minidlna
1573 lfsmake2 acpid
1574 lfsmake2 fping
1575 lfsmake2 telnet
1576 lfsmake2 xinetd
1577 lfsmake2 gpgme
1578 lfsmake2 pygpgme
1579 lfsmake2 pakfire3
1580 lfsmake2 stress
1581 lfsmake2 libstatgrab
1582 lfsmake2 sarg
1583 lfsmake2 nginx
1584 lfsmake2 sendEmail
1585 lfsmake2 sysbench
1586 lfsmake2 strace
1587 lfsmake2 ltrace
1588 lfsmake2 ipfire-netboot
1589 lfsmake2 lcdproc
1590 lfsmake2 keepalived
1591 lfsmake2 ipvsadm
1592 lfsmake2 perl-Carp-Clan
1593 lfsmake2 perl-Date-Calc
1594 lfsmake2 perl-Date-Manip
1595 lfsmake2 perl-File-Tail
1596 lfsmake2 perl-TimeDate
1597 lfsmake2 swatch
1598 lfsmake2 tor
1599 lfsmake2 wavemon
1600 lfsmake2 iptraf-ng
1601 lfsmake2 iotop
1602 lfsmake2 stunnel
1603 lfsmake2 bacula
1604 lfsmake2 perl-Font-TTF
1605 lfsmake2 perl-IO-String
1606 lfsmake2 perl-PDF-API2
1607 lfsmake2 squid-accounting
1608 lfsmake2 pigz
1609 lfsmake2 tmux
1610 lfsmake2 perl-Text-CSV_XS
1611 lfsmake2 lua
1612 lfsmake2 haproxy
1613 lfsmake2 ipset
1614 lfsmake2 dnsdist
1615 lfsmake2 bird
1616 lfsmake2 frr
1617 lfsmake2 dmidecode
1618 lfsmake2 mcelog
1619 lfsmake2 util-macros
1620 lfsmake2 libpciaccess
1621 lfsmake2 libyajl
1622 lfsmake2 libvirt
1623 lfsmake2 freeradius
1624 lfsmake2 perl-common-sense
1625 lfsmake2 perl-inotify2
1626 lfsmake2 perl-Net-IP
1627 lfsmake2 wio
1628 lfsmake2 iftop
1629 lfsmake2 mdns-repeater
1630 lfsmake2 i2c-tools
1631 lfsmake2 nss-myhostname
1632 lfsmake2 dehydrated
1633 lfsmake2 shairport-sync
1634 lfsmake2 borgbackup
1635 lfsmake2 knot
1636 lfsmake2 spectre-meltdown-checker
1637 lfsmake2 zabbix_agentd
1638 lfsmake2 flashrom
1639 lfsmake2 firmware-update
1640 lfsmake2 tshark
1641 lfsmake2 geoip-generator
1642 lfsmake2 speedtest-cli
1643 lfsmake2 rfkill
1644 lfsmake2 amazon-ssm-agent
1645 }
1646
1647 buildinstaller() {
1648 # Run installer scripts one by one
1649 LOGFILE="$BASEDIR/log/_build.installer.log"
1650 export LOGFILE
1651 lfsmake2 memtest
1652 lfsmake2 installer
1653 # use toolchain bash for chroot to strip
1654 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1655 }
1656
1657 buildpackages() {
1658 LOGFILE="$BASEDIR/log/_build.packages.log"
1659 export LOGFILE
1660 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1661
1662
1663 # Generating list of packages used
1664 print_line "Generating packages list from logs"
1665 rm -f $BASEDIR/doc/packages-list
1666 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1667 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1668 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1669 fi
1670 done
1671 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1672 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1673 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1674 rm -f $BASEDIR/doc/packages-list
1675 # packages-list.txt is ready to be displayed for wiki page
1676 print_status DONE
1677
1678 # Update changelog
1679 cd $BASEDIR
1680 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1681 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1682 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1683
1684 # Create images for install
1685 lfsmake2 cdrom
1686
1687 # Check if there is a loop device for building in virtual environments
1688 modprobe loop 2>/dev/null
1689 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1690 lfsmake2 flash-images
1691 fi
1692
1693 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1694
1695 ipfirepackages
1696
1697 lfsmake2 xen-image
1698 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
1699
1700 cd $BASEDIR
1701
1702 # remove not useable iso on armv5tel (needed to build flash images)
1703 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1704
1705 for i in `ls *.bz2 *.img.xz *.iso`; do
1706 md5sum $i > $i.md5
1707 done
1708 cd $PWD
1709
1710 # Cleanup
1711 stdumount
1712 rm -rf $BASEDIR/build/tmp/*
1713
1714 cd $PWD
1715 }
1716
1717 ipfirepackages() {
1718 lfsmake2 core-updates
1719
1720 local i
1721 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1722 i=$(basename ${i})
1723 if [ -e $BASEDIR/lfs/$i ]; then
1724 ipfiredist $i
1725 else
1726 echo -n $i
1727 print_status SKIP
1728 fi
1729 done
1730 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1731 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1732 rm -rf $BASEDIR/build/install/packages/*
1733 }
1734
1735 while [ $# -gt 0 ]; do
1736 case "${1}" in
1737 --target=*)
1738 configure_build "${1#--target=}"
1739 ;;
1740 -*)
1741 exiterror "Unknown configuration option: ${1}"
1742 ;;
1743 *)
1744 # Found a command, so exit options parsing.
1745 break
1746 ;;
1747 esac
1748 shift
1749 done
1750
1751 # See what we're supposed to do
1752 case "$1" in
1753 build)
1754 START_TIME=$(now)
1755
1756 # Clear screen
1757 ${INTERACTIVE} && clear
1758
1759 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1760 #only restore on a clean disk
1761 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1762 if [ ! -n "$PACKAGE" ]; then
1763 print_build_stage "Full toolchain compilation"
1764 prepareenv
1765 buildtoolchain
1766 else
1767 PACKAGENAME=${PACKAGE%.tar.xz}
1768 print_build_stage "Packaged toolchain compilation"
1769 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1770 tar axf $PACKAGE
1771 prepareenv
1772 else
1773 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1774 fi
1775 fi
1776 else
1777 prepareenv
1778 fi
1779
1780 print_build_stage "Building LFS"
1781 buildbase
1782
1783 print_build_stage "Building IPFire"
1784 buildipfire
1785
1786 print_build_stage "Building installer"
1787 buildinstaller
1788
1789 print_build_stage "Building packages"
1790 buildpackages
1791
1792 print_build_stage "Checking Logfiles for new Files"
1793
1794 cd $BASEDIR
1795 tools/checknewlog.pl
1796 tools/checkrootfiles
1797 cd $PWD
1798
1799 print_build_summary $(( $(now) - ${START_TIME} ))
1800 ;;
1801 shell)
1802 # enter a shell inside LFS chroot
1803 # may be used to changed kernel settings
1804 prepareenv
1805 entershell
1806 ;;
1807 clean)
1808 print_line "Cleaning build directory..."
1809
1810 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1811 $LOSETUP -d $i 2>/dev/null
1812 done
1813 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1814 umount $i
1815 done
1816 stdumount
1817 for i in `seq 0 7`; do
1818 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1819 umount /dev/loop${i} 2>/dev/null;
1820 losetup -d /dev/loop${i} 2>/dev/null;
1821 fi;
1822 done
1823 rm -rf $BASEDIR/build
1824 rm -rf $BASEDIR/cdrom
1825 rm -rf $BASEDIR/packages
1826 rm -rf $BASEDIR/log
1827 if [ -h "${TOOLS_DIR}" ]; then
1828 rm -f "${TOOLS_DIR}"
1829 fi
1830 rm -f $BASEDIR/ipfire-*
1831 print_status DONE
1832 ;;
1833 docker)
1834 # Build the docker image if it does not exist, yet
1835 if ! docker images -a | grep -q ^ipfire-builder; then
1836 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1837 print_status DONE
1838 else
1839 print_status FAIL
1840 exit 1
1841 fi
1842 fi
1843
1844 # Run the container and enter a shell
1845 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1846 ;;
1847 downloadsrc)
1848 if [ ! -d $BASEDIR/cache ]; then
1849 mkdir $BASEDIR/cache
1850 fi
1851 mkdir -p $BASEDIR/log
1852 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1853 FINISHED=0
1854 cd $BASEDIR/lfs
1855 for c in `seq $MAX_RETRIES`; do
1856 if (( FINISHED==1 )); then
1857 break
1858 fi
1859 FINISHED=1
1860 cd $BASEDIR/lfs
1861 for i in *; do
1862 if [ -f "$i" -a "$i" != "Config" ]; then
1863 lfsmakecommoncheck ${i} || continue
1864
1865 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1866 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1867 if [ $? -ne 0 ]; then
1868 print_status FAIL
1869 FINISHED=0
1870 else
1871 if [ $c -eq 1 ]; then
1872 print_status DONE
1873 fi
1874 fi
1875 fi
1876 done
1877 done
1878 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1879 ERROR=0
1880 for i in *; do
1881 if [ -f "$i" -a "$i" != "Config" ]; then
1882 lfsmakecommoncheck ${i} > /dev/null || continue
1883 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1884 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1885 if [ $? -ne 0 ]; then
1886 echo -ne "MD5 difference in lfs/$i"
1887 print_status FAIL
1888 ERROR=1
1889 fi
1890 fi
1891 done
1892 if [ $ERROR -eq 0 ]; then
1893 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1894 print_status DONE
1895 else
1896 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1897 print_status FAIL
1898 fi
1899 cd - >/dev/null 2>&1
1900 ;;
1901 toolchain)
1902 # Clear screen
1903 ${INTERACTIVE} && clear
1904
1905 prepareenv
1906 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1907 buildtoolchain
1908 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1909 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1910 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
1911 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
1912 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1913 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1914 stdumount
1915 ;;
1916 gettoolchain)
1917 # arbitrary name to be updated in case of new toolchain package upload
1918 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1919 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1920 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1921 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1922 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1923 cd $BASEDIR/cache/toolchains
1924 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1925 if [ $? -ne 0 ]; then
1926 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1927 else
1928 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1929 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1930 else
1931 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1932 fi
1933 fi
1934 else
1935 echo "Toolchain is already downloaded. Exiting..."
1936 fi
1937 ;;
1938 uploadsrc)
1939 PWD=`pwd`
1940 if [ -z $IPFIRE_USER ]; then
1941 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1942 print_status FAIL
1943 exit 1
1944 fi
1945
1946 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1947 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1948
1949 for file in ${BASEDIR}/cache/*; do
1950 [ -d "${file}" ] && continue
1951 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1952 NEW_FILES="$NEW_FILES $file"
1953 done
1954 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1955 cd $BASEDIR
1956 cd $PWD
1957 exit 0
1958 ;;
1959 lang)
1960 echo -ne "Checking the translations for missing or obsolete strings..."
1961 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1962 $BASEDIR/tools/sort_strings.pl en
1963 $BASEDIR/tools/sort_strings.pl de
1964 $BASEDIR/tools/sort_strings.pl fr
1965 $BASEDIR/tools/sort_strings.pl es
1966 $BASEDIR/tools/sort_strings.pl pl
1967 $BASEDIR/tools/sort_strings.pl ru
1968 $BASEDIR/tools/sort_strings.pl nl
1969 $BASEDIR/tools/sort_strings.pl tr
1970 $BASEDIR/tools/sort_strings.pl it
1971 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1972 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1973 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1974 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1975 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1976 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1977 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1978 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1979 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1980 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1981 print_status DONE
1982
1983 echo -ne "Updating language lists..."
1984 update_language_list ${BASEDIR}/src/installer/po
1985 update_language_list ${BASEDIR}/src/setup/po
1986 print_status DONE
1987 ;;
1988 update-contributors)
1989 update_contributors
1990 ;;
1991 *)
1992 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
1993 cat doc/make.sh-usage
1994 ;;
1995 esac